diff -urN soojung-0.4.12/admin.php soojung/admin.php
--- soojung-0.4.12/admin.php	2005-06-24 11:43:18.000000000 +0900
+++ soojung/admin.php	2005-11-04 16:48:30.000000000 +0900
@@ -175,7 +175,7 @@
     }
     $template->assign('prev_page_link', $prev_link);
   }
-  if ($count > $page * 10) {
+  if ($count > $page * 25) {
     $next_link = "admin.php?mode=list&page=" . ($page + 1);
     if (isset($_GET["flag"])) {
       $next_link .= "&flag=" . urlencode($_GET["flag"]);
@@ -185,12 +185,12 @@
 
 
   if ($_GET["flag"] == "static") {
-    $template->assign('entries', Entry::getStaticEntries(10, $page));
+    $template->assign('entries', Entry::getStaticEntries(25, $page));
   } else if (category_in_array($_GET["flag"], $categories)) {
     $cate = new Category($_GET["flag"]);
-    $template->assign('entries', $cate->getEntries(10, $page));
+    $template->assign('entries', $cate->getEntries(25, $page));
   } else {
-    $template->assign('entries', Entry::getEntries(10, $page, false));
+    $template->assign('entries', Entry::getEntries(25, $page, false));
   }
 
   $template->assign("categories", $categories);
diff -urN soojung-0.4.12/classes/Formatter.class.php soojung/classes/Formatter.class.php
--- soojung-0.4.12/classes/Formatter.class.php	2005-10-25 10:04:51.000000000 +0900
+++ soojung/classes/Formatter.class.php	2005-10-29 00:39:02.000000000 +0900
@@ -206,8 +206,8 @@
         'BBcodeFormatter::__listing("\1","\2")',
         'BBcodeFormatter::__escape("<a href=\\"\1\\">\1</a>")',
         'BBcodeFormatter::__escape("<a href=\\"\2\\">\3</a>")',
-        'BBcodeFormatter::__escape("<img src=\\"\1\\" alt=\\"\1\\\" class=\\"bbcode\\" />")',
-        'BBcodeFormatter::__escape("<img src=\\"\2\\" alt=\\"\3\\\" class=\\"bbcodd\\" />")',
+        'BBcodeFormatter::__escape("<img src=\\"".htmlspecialchars("\1")."\\" alt=\\"\1\\\" class=\\"bbcode\\" />")',
+        'BBcodeFormatter::__escape("<img src=\\"".htmlspecialchars("\2")."\\" alt=\\"\3\\\" class=\\"bbcodd\\" />")',
         'BBcodeFormatter::__escape("<a href=\\"mailto:\1\\">\1</a>")'),
       $rule2 = array(
         '#(?<![\/~"\'])http://(?:[-0-9a-z_.@:~\\#%=+?/]|&amp;)+(?!(?:</a>|"|\'>))#i',
diff -urN soojung-0.4.12/install.php soojung/install.php
--- soojung-0.4.12/install.php	2005-06-24 11:43:18.000000000 +0900
+++ soojung/install.php	2005-11-10 10:38:42.000000000 +0900
@@ -81,37 +81,37 @@
 
 <tr>
 <td>* Blog Name:</td>
-<td><input type="text" name="name" size="30" value="<?=isset($_POST['name']) ? $_POST['name'] : ""?>"></td>
+<td><input type="text" name="name" size="30" value="<?php echo isset($_POST['name']) ? $_POST['name'] : "" ?>"></td>
 </tr>
 
 <tr>
 <td>* Blog Description:</td>
-<td><input type="text" name="desc" size="50" value="<?=isset($_POST['desc']) ? $_POST['desc'] : ""?>"></td>
+<td><input type="text" name="desc" size="50" value="<?php echo isset($_POST['desc']) ? $_POST['desc'] : "" ?>"></td>
 </tr>
 
 <tr>
 <td>* Blog URL:</td>
-<td><input type="text" name="url" size="50" value="<?=isset($_POST['url']) ? $_POST['url'] : 'http://' . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF'])?>"></td>
+<td><input type="text" name="url" size="50" value="<?php echo isset($_POST['url']) ? $_POST['url'] : 'http://' . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']) ?>"></td>
 </tr>
 
 <tr>
 <td>* Admin name:</td>
-<td><input type="text" name="admin" value="<?=isset($_POST['admin']) ? $_POST['admin'] : ""?>"></td>
+<td><input type="text" name="admin" value="<?php echo isset($_POST['admin']) ? $_POST['admin'] : "" ?>"></td>
 </tr>
 
 <tr>
 <td>* Admin email:</td>
-<td><input type="text" name="email" value="<?=isset($_POST['email']) ? $_POST['email'] : ""?>"></td>
+<td><input type="text" name="email" value="<?php echo isset($_POST['email']) ? $_POST['email'] : "" ?>"></td>
 </tr>
 
 <tr>
 <td>* Admin password:</td>
-<td><input type="password" name="password" value="<?=isset($POST['password']) ? $_POST['password'] : ""?>"></td>
+<td><input type="password" name="password" value="<?php echo isset($POST['password']) ? $_POST['password'] : "" ?>"></td>
 </tr>
 
 <tr>
 <td>entries per page</td>
-<td><input type="text" name="perpage" size="2" value="<?=isset($_POST['perpage']) ? $_POST['perpage'] : 5?>"></td>
+<td><input type="text" name="perpage" size="2" value="<?php echo isset($_POST['perpage']) ? $_POST['perpage'] : 5 ?>"></td>
 </tr>
 
 <tr>
diff -urN soojung-0.4.12/libs/util.php soojung/libs/util.php
--- soojung-0.4.12/libs/util.php	2005-10-16 16:40:51.000000000 +0900
+++ soojung/libs/util.php	2005-11-04 16:37:58.000000000 +0900
@@ -158,6 +158,47 @@
 }
 
 function locked_filewrite($filename, $data) {
+    ignore_user_abort(1);
+    $lockfile = $filename . '.lock';
+
+   // if a lockfile already exists, but it is more than 5 seconds old,
+   // we assume the last process failed to delete it
+   // this would be very rare, but possible and must be accounted for
+    if (file_exists($lockfile)) {
+        if (time() - filemtime($lockfile) > 5) unlink($lockfile);
+    }
+
+    $i = 0;
+    while (true) {
+        // lock 생성할때까지 20번 루프를 돌아본다
+        if (!file_exists($lockfile)) {
+            $acquired = true;
+            touch ($lockfile);
+            break;
+        } else if ($i < 20) {
+            clearstatcache();
+            usleep(rand(9,999));
+            $i += 1;
+        } else {
+            $acquired = false;
+            break;
+        }
+    }
+
+    $success = false;
+    if ($acquired) {
+        $fp = @fopen($filename, 'w');
+        if (@fwrite($fp, $data)) $success = true;
+        @fclose($fp);
+        unlink($lockfile);
+    }
+
+    ignore_user_abort(0);
+    return $success;
+}
+
+
+function locked_filewrite_($filename, $data) {
    ignore_user_abort(1);
    $lockfile = $filename . '.lock';
 
diff -urN soojung-0.4.12/libs/xmlrpc.inc soojung/libs/xmlrpc.inc
--- soojung-0.4.12/libs/xmlrpc.inc	2004-09-13 00:56:15.000000000 +0900
+++ soojung/libs/xmlrpc.inc	2005-11-09 09:37:59.000000000 +0900
@@ -1,7 +1,7 @@
 <?php					// -*-c++-*-
 // by Edd Dumbill (C) 1999-2002
 // <edd@usefulinc.com>
-// $Id: xmlrpc.inc,v 1.2 2004/09/12 15:56:15 mithrandir Exp $
+// $Id: xmlrpc.inc,v 1.3 2005/11/09 00:37:59 ddt Exp $
 
 
 // Copyright (c) 1999,2000,2002 Edd Dumbill.
@@ -49,6 +49,35 @@
 		}
 	}
 
+	// G. Giunta 2005/01/29: declare global these variables,
+	// so that xmlrpc.inc will work even if included from within a function
+	// NB: it will give warnings in PHP3, so we comment it out
+	// Milosch: Next round, maybe we should explicitly request these via $GLOBALS where used.
+	if (phpversion() >= '4')
+	{
+		global $xmlrpcI4;
+		global $xmlrpcInt;
+		global $xmlrpcDouble;
+		global $xmlrpcBoolean;
+		global $xmlrpcString;
+		global $xmlrpcDateTime;
+		global $xmlrpcBase64;
+		global $xmlrpcArray;
+		global $xmlrpcStruct;
+
+		global $xmlrpcTypes;
+		global $xmlEntities;
+		global $xmlrpcerr;
+		global $xmlrpcstr;
+		global $xmlrpc_defencoding;
+		global $xmlrpc_internalencoding;
+		global $xmlrpcName;
+		global $xmlrpcVersion;
+		global $xmlrpcerruser;
+		global $xmlrpcerrxml;
+		global $xmlrpc_backslash;
+		global $_xh;
+	}
 	$xmlrpcI4='i4';
 	$xmlrpcInt='int';
 	$xmlrpcBoolean='boolean';
@@ -71,6 +100,26 @@
 		$xmlrpcStruct   => 3
 	);
 
+	$xmlrpc_valid_parents = array(
+		'BOOLEAN' => array('VALUE' => 'VALUE'),
+		'I4' => array('VALUE' => 'VALUE'),
+		'INT' => array('VALUE' => 'VALUE'),
+		'STRING' => array('VALUE' => 'VALUE'),
+		'DOUBLE' => array('VALUE' => 'VALUE'),
+		'DATETIME.ISO8601' => array('VALUE' => 'VALUE'),
+		'BASE64' => array('VALUE' => 'VALUE'),
+		'ARRAY' => array('VALUE' => 'VALUE'),
+		'STRUCT' => array('VALUE' => 'VALUE'),
+		'PARAM' => array('PARAMS' => 'PARAMS'),
+		'METHODNAME' => array('METHODCALL' => 'METHODCALL'),
+		'PARAMS' => array('METHODCALL' => 'METHODCALL', 'METHODRESPONSE' => 'METHODRESPONSE'),
+		'MEMBER' => array('STRUCT' => 'STRUCT'),
+		'NAME' => array('MEMBER' => 'MEMBER'),
+		'DATA' => array('ARRAY' => 'ARRAY'),
+		'FAULT' => array('METHODRESPONSE' => 'METHODRESPONSE'),
+		'VALUE' => array('MEMBER' => 'MEMBER', 'DATA' => 'DATA', 'PARAM' => 'PARAM', 'FAULT' => 'FAULT')
+	);
+
 	$xmlEntities=array(
 		'amp'  => '&',
 		'quot' => '"',
@@ -82,7 +131,7 @@
 	$xmlrpcerr['unknown_method']=1;
 	$xmlrpcstr['unknown_method']='Unknown method';
 	$xmlrpcerr['invalid_return']=2;
-	$xmlrpcstr['invalid_return']='Invalid return payload: enabling debugging to examine incoming payload';
+	$xmlrpcstr['invalid_return']='Invalid return payload: enable debugging to examine incoming payload';
 	$xmlrpcerr['incorrect_params']=3;
 	$xmlrpcstr['incorrect_params']='Incorrect parameters passed to method';
 	$xmlrpcerr['introspect_unknown']=4;
@@ -95,7 +144,8 @@
 	$xmlrpcstr['no_ssl']='No SSL support compiled in.';
 	$xmlrpcerr['curl_fail']=8;
 	$xmlrpcstr['curl_fail']='CURL error';
-
+	$xmlrpcerr['invalid_request']=15;
+	$xmlrpcstr['invalid_request']='Invalid request payload';
 
 	$xmlrpcerr['multicall_notstruct'] = 9;
 	$xmlrpcstr['multicall_notstruct'] = 'system.multicall expected struct';
@@ -110,13 +160,18 @@
 	$xmlrpcerr['multicall_notarray']  = 14;
 	$xmlrpcstr['multicall_notarray']  = 'params is not an array';
 
+	// The charset encoding expected by the server for received messages and
+	// by the client for received responses
 	$xmlrpc_defencoding='UTF-8';
+	// The encoding used by PHP.
+	// String values received will be converted to this.
+	$xmlrpc_internalencoding='ISO-8859-1';
 
 	$xmlrpcName='XML-RPC for PHP';
-	$xmlrpcVersion='1.0.99';
+	$xmlrpcVersion='1.2.1';
 
 	// let user errors start at 800
-	$xmlrpcerruser=800; 
+	$xmlrpcerruser=800;
 	// let XML parse errors start at 100
 	$xmlrpcerrxml=100;
 
@@ -125,23 +180,30 @@
 
 	// used to store state during parsing
 	// quick explanation of components:
-	//   st - used to build up a string for evaluation
 	//   ac - used to accumulate values
-	//   qt - used to decide if quotes are needed for evaluation
-	//   cm - used to denote struct or array (comma needed)
 	//   isf - used to indicate a fault
 	//   lv - used to indicate "looking for a value": implements
 	//        the logic to allow values with no types to be strings
 	//   params - used to store parameters in method calls
 	//   method - used to store method name
+	//   stack - array with genealogy of xml elements names:
+	//           used to validate nesting of xmlrpc elements
 
 	$_xh=array();
 
+	/**
+	* To help correct communication of non-ascii chars inside strings, regardless
+	* of the charset used when sending requests, parsing them, sending responses
+	* and parsing responses, convert all non-ascii chars present in the message
+	* into their equivalent 'charset entity'. Charset entities enumerated this way
+	* are independent of the charset encoding used to transmit them, and all XML
+	* parsers are bound to understand them.
+	*/
 	function xmlrpc_entity_decode($string)
 	{
 		$top=split('&', $string);
 		$op='';
-		$i=0; 
+		$i=0;
 		while($i<sizeof($top))
 		{
 			if (ereg("^([#a-zA-Z0-9]+);", $top[$i], $regs))
@@ -181,39 +243,370 @@
 		return '?';
 	}
 
+	/**
+	 * These entities originate from HTML specs (1.1, proposed 2.0, etc),
+	 * and are taken directly from php-4.3.1/ext/mbstring/html_entities.c.
+	 * Until php provides functionality to translate these entities in its
+	 * core library, use this function.
+	 */
+	function xmlrpc_html_entity_xlate($data = '')
+	{
+		$entities = array(
+			"&nbsp;" => "&#160;",
+			"&iexcl;" => "&#161;",
+			"&cent;" => "&#162;",
+			"&pound;" => "&#163;",
+			"&curren;" => "&#164;",
+			"&yen;" => "&#165;",
+			"&brvbar;" => "&#166;",
+			"&sect;" => "&#167;",
+			"&uml;" => "&#168;",
+			"&copy;" => "&#169;",
+			"&ordf;" => "&#170;",
+			"&laquo;" => "&#171;",
+			"&not;" => "&#172;",
+			"&shy;" => "&#173;",
+			"&reg;" => "&#174;",
+			"&macr;" => "&#175;",
+			"&deg;" => "&#176;",
+			"&plusmn;" => "&#177;",
+			"&sup2;" => "&#178;",
+			"&sup3;" => "&#179;",
+			"&acute;" => "&#180;",
+			"&micro;" => "&#181;",
+			"&para;" => "&#182;",
+			"&middot;" => "&#183;",
+			"&cedil;" => "&#184;",
+			"&sup1;" => "&#185;",
+			"&ordm;" => "&#186;",
+			"&raquo;" => "&#187;",
+			"&frac14;" => "&#188;",
+			"&frac12;" => "&#189;",
+			"&frac34;" => "&#190;",
+			"&iquest;" => "&#191;",
+			"&Agrave;" => "&#192;",
+			"&Aacute;" => "&#193;",
+			"&Acirc;" => "&#194;",
+			"&Atilde;" => "&#195;",
+			"&Auml;" => "&#196;",
+			"&Aring;" => "&#197;",
+			"&AElig;" => "&#198;",
+			"&Ccedil;" => "&#199;",
+			"&Egrave;" => "&#200;",
+			"&Eacute;" => "&#201;",
+			"&Ecirc;" => "&#202;",
+			"&Euml;" => "&#203;",
+			"&Igrave;" => "&#204;",
+			"&Iacute;" => "&#205;",
+			"&Icirc;" => "&#206;",
+			"&Iuml;" => "&#207;",
+			"&ETH;" => "&#208;",
+			"&Ntilde;" => "&#209;",
+			"&Ograve;" => "&#210;",
+			"&Oacute;" => "&#211;",
+			"&Ocirc;" => "&#212;",
+			"&Otilde;" => "&#213;",
+			"&Ouml;" => "&#214;",
+			"&times;" => "&#215;",
+			"&Oslash;" => "&#216;",
+			"&Ugrave;" => "&#217;",
+			"&Uacute;" => "&#218;",
+			"&Ucirc;" => "&#219;",
+			"&Uuml;" => "&#220;",
+			"&Yacute;" => "&#221;",
+			"&THORN;" => "&#222;",
+			"&szlig;" => "&#223;",
+			"&agrave;" => "&#224;",
+			"&aacute;" => "&#225;",
+			"&acirc;" => "&#226;",
+			"&atilde;" => "&#227;",
+			"&auml;" => "&#228;",
+			"&aring;" => "&#229;",
+			"&aelig;" => "&#230;",
+			"&ccedil;" => "&#231;",
+			"&egrave;" => "&#232;",
+			"&eacute;" => "&#233;",
+			"&ecirc;" => "&#234;",
+			"&euml;" => "&#235;",
+			"&igrave;" => "&#236;",
+			"&iacute;" => "&#237;",
+			"&icirc;" => "&#238;",
+			"&iuml;" => "&#239;",
+			"&eth;" => "&#240;",
+			"&ntilde;" => "&#241;",
+			"&ograve;" => "&#242;",
+			"&oacute;" => "&#243;",
+			"&ocirc;" => "&#244;",
+			"&otilde;" => "&#245;",
+			"&ouml;" => "&#246;",
+			"&divide;" => "&#247;",
+			"&oslash;" => "&#248;",
+			"&ugrave;" => "&#249;",
+			"&uacute;" => "&#250;",
+			"&ucirc;" => "&#251;",
+			"&uuml;" => "&#252;",
+			"&yacute;" => "&#253;",
+			"&thorn;" => "&#254;",
+			"&yuml;" => "&#255;",
+			"&OElig;" => "&#338;",
+			"&oelig;" => "&#339;",
+			"&Scaron;" => "&#352;",
+			"&scaron;" => "&#353;",
+			"&Yuml;" => "&#376;",
+			"&fnof;" => "&#402;",
+			"&circ;" => "&#710;",
+			"&tilde;" => "&#732;",
+			"&Alpha;" => "&#913;",
+			"&Beta;" => "&#914;",
+			"&Gamma;" => "&#915;",
+			"&Delta;" => "&#916;",
+			"&Epsilon;" => "&#917;",
+			"&Zeta;" => "&#918;",
+			"&Eta;" => "&#919;",
+			"&Theta;" => "&#920;",
+			"&Iota;" => "&#921;",
+			"&Kappa;" => "&#922;",
+			"&Lambda;" => "&#923;",
+			"&Mu;" => "&#924;",
+			"&Nu;" => "&#925;",
+			"&Xi;" => "&#926;",
+			"&Omicron;" => "&#927;",
+			"&Pi;" => "&#928;",
+			"&Rho;" => "&#929;",
+			"&Sigma;" => "&#931;",
+			"&Tau;" => "&#932;",
+			"&Upsilon;" => "&#933;",
+			"&Phi;" => "&#934;",
+			"&Chi;" => "&#935;",
+			"&Psi;" => "&#936;",
+			"&Omega;" => "&#937;",
+			"&beta;" => "&#946;",
+			"&gamma;" => "&#947;",
+			"&delta;" => "&#948;",
+			"&epsilon;" => "&#949;",
+			"&zeta;" => "&#950;",
+			"&eta;" => "&#951;",
+			"&theta;" => "&#952;",
+			"&iota;" => "&#953;",
+			"&kappa;" => "&#954;",
+			"&lambda;" => "&#955;",
+			"&mu;" => "&#956;",
+			"&nu;" => "&#957;",
+			"&xi;" => "&#958;",
+			"&omicron;" => "&#959;",
+			"&pi;" => "&#960;",
+			"&rho;" => "&#961;",
+			"&sigmaf;" => "&#962;",
+			"&sigma;" => "&#963;",
+			"&tau;" => "&#964;",
+			"&upsilon;" => "&#965;",
+			"&phi;" => "&#966;",
+			"&chi;" => "&#967;",
+			"&psi;" => "&#968;",
+			"&omega;" => "&#969;",
+			"&thetasym;" => "&#977;",
+			"&upsih;" => "&#978;",
+			"&piv;" => "&#982;",
+			"&ensp;" => "&#8194;",
+			"&emsp;" => "&#8195;",
+			"&thinsp;" => "&#8201;",
+			"&zwnj;" => "&#8204;",
+			"&zwj;" => "&#8205;",
+			"&lrm;" => "&#8206;",
+			"&rlm;" => "&#8207;",
+			"&ndash;" => "&#8211;",
+			"&mdash;" => "&#8212;",
+			"&lsquo;" => "&#8216;",
+			"&rsquo;" => "&#8217;",
+			"&sbquo;" => "&#8218;",
+			"&ldquo;" => "&#8220;",
+			"&rdquo;" => "&#8221;",
+			"&bdquo;" => "&#8222;",
+			"&dagger;" => "&#8224;",
+			"&Dagger;" => "&#8225;",
+			"&bull;" => "&#8226;",
+			"&hellip;" => "&#8230;",
+			"&permil;" => "&#8240;",
+			"&prime;" => "&#8242;",
+			"&Prime;" => "&#8243;",
+			"&lsaquo;" => "&#8249;",
+			"&rsaquo;" => "&#8250;",
+			"&oline;" => "&#8254;",
+			"&frasl;" => "&#8260;",
+			"&euro;" => "&#8364;",
+			"&weierp;" => "&#8472;",
+			"&image;" => "&#8465;",
+			"&real;" => "&#8476;",
+			"&trade;" => "&#8482;",
+			"&alefsym;" => "&#8501;",
+			"&larr;" => "&#8592;",
+			"&uarr;" => "&#8593;",
+			"&rarr;" => "&#8594;",
+			"&darr;" => "&#8595;",
+			"&harr;" => "&#8596;",
+			"&crarr;" => "&#8629;",
+			"&lArr;" => "&#8656;",
+			"&uArr;" => "&#8657;",
+			"&rArr;" => "&#8658;",
+			"&dArr;" => "&#8659;",
+			"&hArr;" => "&#8660;",
+			"&forall;" => "&#8704;",
+			"&part;" => "&#8706;",
+			"&exist;" => "&#8707;",
+			"&empty;" => "&#8709;",
+			"&nabla;" => "&#8711;",
+			"&isin;" => "&#8712;",
+			"&notin;" => "&#8713;",
+			"&ni;" => "&#8715;",
+			"&prod;" => "&#8719;",
+			"&sum;" => "&#8721;",
+			"&minus;" => "&#8722;",
+			"&lowast;" => "&#8727;",
+			"&radic;" => "&#8730;",
+			"&prop;" => "&#8733;",
+			"&infin;" => "&#8734;",
+			"&ang;" => "&#8736;",
+			"&and;" => "&#8743;",
+			"&or;" => "&#8744;",
+			"&cap;" => "&#8745;",
+			"&cup;" => "&#8746;",
+			"&int;" => "&#8747;",
+			"&there4;" => "&#8756;",
+			"&sim;" => "&#8764;",
+			"&cong;" => "&#8773;",
+			"&asymp;" => "&#8776;",
+			"&ne;" => "&#8800;",
+			"&equiv;" => "&#8801;",
+			"&le;" => "&#8804;",
+			"&ge;" => "&#8805;",
+			"&sub;" => "&#8834;",
+			"&sup;" => "&#8835;",
+			"&nsub;" => "&#8836;",
+			"&sube;" => "&#8838;",
+			"&supe;" => "&#8839;",
+			"&oplus;" => "&#8853;",
+			"&otimes;" => "&#8855;",
+			"&perp;" => "&#8869;",
+			"&sdot;" => "&#8901;",
+			"&lceil;" => "&#8968;",
+			"&rceil;" => "&#8969;",
+			"&lfloor;" => "&#8970;",
+			"&rfloor;" => "&#8971;",
+			"&lang;" => "&#9001;",
+			"&rang;" => "&#9002;",
+			"&loz;" => "&#9674;",
+			"&spades;" => "&#9824;",
+			"&clubs;" => "&#9827;",
+			"&hearts;" => "&#9829;",
+			"&diams;" => "&#9830;");
+		return strtr($data, $entities);
+	}
+
+	function xmlrpc_encode_entitites($data)
+	{
+		$length = strlen($data);
+		$escapeddata = "";
+		for($position = 0; $position < $length; $position++)
+		{
+			$character = substr($data, $position, 1);
+			$code = Ord($character);
+			switch($code) {
+				case 34:
+				$character = "&quot;";
+				break;
+				case 38:
+				$character = "&amp;";
+				break;
+				case 39:
+				$character = "&apos;";
+				break;
+				case 60:
+				$character = "&lt;";
+				break;
+				case 62:
+				$character = "&gt;";
+				break;
+				default:
+				if ($code < 32 || $code > 159)
+					$character = ("&#".strval($code).";");
+				break;
+			}
+			$escapeddata .= $character;
+		}
+		return $escapeddata;
+	}
+
 	function xmlrpc_se($parser, $name, $attrs)
 	{
-		global $_xh, $xmlrpcDateTime, $xmlrpcString;
+		global $_xh, $xmlrpcDateTime, $xmlrpcString, $xmlrpc_valid_parents;
+
+		// if invalid xmlrpc already detected, skip all processing
+		if ($_xh[$parser]['isf'] < 2)
+		{
+
+		// check for correct element nesting
+		// top level element can only be of 2 types
+		if ($_xh[$parser]['sp'] == 0)
+		{
+			if ($name != 'METHODRESPONSE' && $name != 'METHODCALL')
+			{
+				$_xh[$parser]['isf'] = 2;
+				$_xh[$parser]['isf_reason'] = 'missing top level xmlrpc element';
+				return;
+			}
+		}
+		else
+		{
+			// not top level element: see if parent is OK
+			$parent = $_xh[$parser]['stack'][$_xh[$parser]['sp']-1];
+			if (!isset($xmlrpc_valid_parents[$name][$parent]))
+			{
+				$_xh[$parser]['isf'] = 2;
+				$_xh[$parser]['isf_reason'] = "xmlrpc element $name cannot be child of $parent";
+				return;
+			}
+		}
 
 		switch($name)
 		{
 			case 'STRUCT':
 			case 'ARRAY':
-				$_xh[$parser]['st'].='array(';
-				$_xh[$parser]['cm']++;
+				//$_xh[$parser]['st'].='array(';
+				//$_xh[$parser]['cm']++;
 				// this last line turns quoting off
-				// this means if we get an empty array we'll 
+				// this means if we get an empty array we'll
 				// simply get a bit of whitespace in the eval
-				$_xh[$parser]['qt']=0;
+				//$_xh[$parser]['qt']=0;
+
+				// create an empty array to hold child values, and push it onto appropriate stack
+				$cur_val = array();
+				$cur_val['values'] = array();
+				$cur_val['type'] = $name;
+				$_xh[$parser]['valuestack'][$_xh[$parser]['vsp']] = $cur_val;
+				$_xh[$parser]['vsp']++;
 				break;
+			case 'METHODNAME':
 			case 'NAME':
-				$_xh[$parser]['st'].="'"; $_xh[$parser]['ac']='';
+				//$_xh[$parser]['st'].='"';
+				$_xh[$parser]['ac']='';
 				break;
 			case 'FAULT':
 				$_xh[$parser]['isf']=1;
 				break;
 			case 'PARAM':
-				$_xh[$parser]['st']='';
+				//$_xh[$parser]['st']='';
+				// clear value, so we can check later if no value will passed for this param/member
+				$_xh[$parser]['value']='';
 				break;
 			case 'VALUE':
-				$_xh[$parser]['st'].='new xmlrpcval(';
-				$_xh[$parser]['vt']=$xmlrpcString;
+				//$_xh[$parser]['st'].='new xmlrpcval(';
+				// look for a value: if this is still true by the
+				// time we reach the end tag for value then the type is string
+				// by implication
+				$_xh[$parser]['vt']='value';
 				$_xh[$parser]['ac']='';
-				$_xh[$parser]['qt']=0;
+				//$_xh[$parser]['qt']=0;
 				$_xh[$parser]['lv']=1;
-				// look for a value: if this is still 1 by the
-				// time we reach the first data segment then the type is string
-				// by implication and we need to add in a quote
 				break;
 			case 'I4':
 			case 'INT':
@@ -222,9 +615,18 @@
 			case 'DOUBLE':
 			case 'DATETIME.ISO8601':
 			case 'BASE64':
-				$_xh[$parser]['ac']=''; // reset the accumulator
+				if ($_xh[$parser]['vt']!='value')
+				{
+					//two data elements inside a value: an error occurred!
+					$_xh[$parser]['isf'] = 2;
+					$_xh[$parser]['isf_reason'] = "$name element following a {$_xh[$parser]['vt']} element inside a single value";
+					return;
+				}
 
-				if ($name=='DATETIME.ISO8601' || $name=='STRING')
+				// reset the accumulator
+				$_xh[$parser]['ac']='';
+
+				/*if ($name=='DATETIME.ISO8601' || $name=='STRING')
 				{
 					$_xh[$parser]['qt']=1;
 					if ($name=='DATETIME.ISO8601')
@@ -242,98 +644,178 @@
 					// at the end of the element we must check
 					// for data format errors.
 					$_xh[$parser]['qt']=0;
-				}
+				}*/
 				break;
 			case 'MEMBER':
-				$_xh[$parser]['ac']='';
+				//$_xh[$parser]['ac']='';
+				// avoid warnings later on if no NAME is found before VALUE inside
+				// a struct member predefining member name as NULL
+				$_xh[$parser]['valuestack'][$_xh[$parser]['vsp']-1]['name'] = '';
+				// clear value, so we can check later if no value will passed for this param/member
+				$_xh[$parser]['value']='';
+				break;
+			case 'DATA':
+			case 'METHODCALL':
+			case 'METHODRESPONSE':
+			case 'PARAMS':
+				// valid elements that add little to processing
 				break;
 			default:
+				/// INVALID ELEMENT: RAISE ISF so that it is later recognized!!!
+				$_xh[$parser]['isf'] = 2;
+				$_xh[$parser]['isf_reason'] = "found not-xmlrpc xml element $name";
 				break;
 		}
 
+		// Save current element name to stack, to validate nesting
+		$_xh[$parser]['stack'][$_xh[$parser]['sp']] = $name;
+		$_xh[$parser]['sp']++;
+
 		if ($name!='VALUE')
 		{
 			$_xh[$parser]['lv']=0;
 		}
+		}
 	}
 
 	function xmlrpc_ee($parser, $name)
 	{
-		global $_xh,$xmlrpcTypes,$xmlrpcString;
+		global $_xh,$xmlrpcTypes,$xmlrpcString,$xmlrpcDateTime;
 
+		if ($_xh[$parser]['isf'] < 2)
+		{
+
+		// push this element name from stack
+		// NB: if XML validates, correct opening/closing is guaranteed and
+		// we do not have to check for $name == $curr_elem.
+		// we also checked for proper nesting at start of elements...
+		$_xh[$parser]['sp']--;
+		$curr_elem = $_xh[$parser]['stack'][$_xh[$parser]['sp']];
+		unset($_xh[$parser]['stack'][$_xh[$parser]['sp']]); 
 		switch($name)
 		{
 			case 'STRUCT':
 			case 'ARRAY':
-				if ($_xh[$parser]['cm'] && substr($_xh[$parser]['st'], -1) ==',')
-				{
-					$_xh[$parser]['st']=substr($_xh[$parser]['st'],0,-1);
-				}
-				$_xh[$parser]['st'].=')';
+				//if ($_xh[$parser]['cm'] && substr($_xh[$parser]['st'], -1) ==',')
+				//{
+				//	$_xh[$parser]['st']=substr($_xh[$parser]['st'],0,-1);
+				//}
+				//$_xh[$parser]['st'].=')';
+
+				// fetch out of stack array of values, and promote it to current value
+				$_xh[$parser]['vsp']--;
+				$cur_val = $_xh[$parser]['valuestack'][$_xh[$parser]['vsp']];
+				unset($_xh[$parser]['valuestack'][$_xh[$parser]['vsp']]);
+				$_xh[$parser]['value'] = $cur_val['values'];
+
 				$_xh[$parser]['vt']=strtolower($name);
-				$_xh[$parser]['cm']--;
+				//$_xh[$parser]['cm']--;
 				break;
 			case 'NAME':
-				$_xh[$parser]['st'].= $_xh[$parser]['ac'] . "' => ";
+				//$_xh[$parser]['st'].= $_xh[$parser]['ac'] . '" => ';
+				$_xh[$parser]['valuestack'][$_xh[$parser]['vsp']-1]['name'] = $_xh[$parser]['ac'];
 				break;
 			case 'BOOLEAN':
-				// special case here: we translate boolean 1 or 0 into PHP
-				// constants true or false
-				if ($_xh[$parser]['ac']=='1')
-				{
-					$_xh[$parser]['ac']='true';
-				}
-				else
-				{
-					$_xh[$parser]['ac']='false';
-					$_xh[$parser]['vt']=strtolower($name);
-					// Drop through intentionally.
-				}
 			case 'I4':
 			case 'INT':
 			case 'STRING':
 			case 'DOUBLE':
 			case 'DATETIME.ISO8601':
 			case 'BASE64':
-				if ($_xh[$parser]['qt']==1)
+				$_xh[$parser]['vt']=strtolower($name);
+				//if ($_xh[$parser]['qt']==1)
+				if ($name=='STRING')
 				{
 					// we use double quotes rather than single so backslashification works OK
-					$_xh[$parser]['st'].='"'. $_xh[$parser]['ac'] . '"';
+					//$_xh[$parser]['st'].='"'. $_xh[$parser]['ac'] . '"';
+					$_xh[$parser]['value']=$_xh[$parser]['ac'];
+				}
+				elseif ($name=='DATETIME.ISO8601')
+				{
+					$_xh[$parser]['vt']=$xmlrpcDateTime;
+					$_xh[$parser]['value']=$_xh[$parser]['ac'];
 				}
-				elseif ($_xh[$parser]['qt']==2)
+				elseif ($name=='BASE64')
 				{
-					$_xh[$parser]['st'].="base64_decode('". $_xh[$parser]['ac'] . "')"; 
+					//$_xh[$parser]['st'].='base64_decode("'. $_xh[$parser]['ac'] . '")';
+
+					///@todo check for failure of base64 decoding / catch warnings
+					$_xh[$parser]['value']=base64_decode($_xh[$parser]['ac']);
 				}
 				elseif ($name=='BOOLEAN')
 				{
-					$_xh[$parser]['st'].=$_xh[$parser]['ac'];
+					// special case here: we translate boolean 1 or 0 into PHP
+					// constants true or false
+					// NB: this simple checks helps a lot sanitizing input, ie no
+					// security problems around here
+					if ($_xh[$parser]['ac']=='1')
+					{
+						//$_xh[$parser]['ac']='true';
+						$_xh[$parser]['value']=true;
+					}
+					else
+					{
+						//$_xh[$parser]['ac']='false';
+						// log if receiveing something strange, even though we set the value to false anyway
+						if ($_xh[$parser]['ac']!='0')
+							error_log('XML-RPC: invalid value received in BOOLEAN: '.$_xh[$parser]['ac']);
+						$_xh[$parser]['value']=false;
+					}
+					//$_xh[$parser]['st'].=$_xh[$parser]['ac'];
 				}
-				else
+				elseif ($name=='DOUBLE')
 				{
-					// we have an I4, INT or a DOUBLE
+					// we have a DOUBLE
 					// we must check that only 0123456789-.<space> are characters here
-					if (!ereg("^\-?[0123456789 \t\.]+$", $_xh[$parser]['ac']))
+					if (!ereg("^[+-]?[eE0123456789 \\t\\.]+$", $_xh[$parser]['ac']))
 					{
 						// TODO: find a better way of throwing an error
 						// than this!
-						error_log('XML-RPC: non numeric value received in INT or DOUBLE');
-						$_xh[$parser]['st'].='ERROR_NON_NUMERIC_FOUND';
+						error_log('XML-RPC: non numeric value received in DOUBLE: '.$_xh[$parser]['ac']);
+						//$_xh[$parser]['st'].="'ERROR_NON_NUMERIC_FOUND'";
+						$_xh[$parser]['value']='ERROR_NON_NUMERIC_FOUND';
 					}
 					else
 					{
 						// it's ok, add it on
-						$_xh[$parser]['st'].=$_xh[$parser]['ac'];
+						//$_xh[$parser]['st'].=(double)$_xh[$parser]['ac'];
+						$_xh[$parser]['value']=(double)$_xh[$parser]['ac'];
 					}
 				}
-				$_xh[$parser]['ac']=''; $_xh[$parser]['qt']=0;
+				else
+				{
+					// we have an I4/INT
+					// we must check that only 0123456789-<space> are characters here
+					if (!ereg("^[+-]?[0123456789 \\t]+$", $_xh[$parser]['ac']))
+					{
+						// TODO: find a better way of throwing an error
+						// than this!
+						error_log('XML-RPC: non numeric value received in INT: '.$_xh[$parser]['ac']);
+						//$_xh[$parser]['st'].="'ERROR_NON_NUMERIC_FOUND'";
+						$_xh[$parser]['value']='ERROR_NON_NUMERIC_FOUND';
+					}
+					else
+					{
+						// it's ok, add it on
+						//$_xh[$parser]['st'].=(int)$_xh[$parser]['ac'];
+						$_xh[$parser]['value']=(int)$_xh[$parser]['ac'];
+					}
+				}
+				$_xh[$parser]['ac']='';
+				//$_xh[$parser]['qt']=0;
 				$_xh[$parser]['lv']=3; // indicate we've found a value
 				break;
 			case 'VALUE':
-				// deal with a string value
-				if (strlen($_xh[$parser]['ac'])>0 &&
+				// This if() detects if no scalar was inside <VALUE></VALUE>
+				if ($_xh[$parser]['vt']=='value')
+				{
+					$_xh[$parser]['value']=$_xh[$parser]['ac'];
+					$_xh[$parser]['vt']=$xmlrpcString;
+				}
+				/*if (strlen($_xh[$parser]['ac'])>0 &&
 					$_xh[$parser]['vt']==$xmlrpcString)
 				{
-					$_xh[$parser]['st'].='"'. $_xh[$parser]['ac'] . '"'; 
+					$_xh[$parser]['st'].='"'. $_xh[$parser]['ac'] . '"';
 				}
 				// This if() detects if no scalar was inside <VALUE></VALUE>
 				// and pads an empty ''.
@@ -341,45 +823,74 @@
 				{
 					$_xh[$parser]['st'].= '""';
 				}
-				$_xh[$parser]['st'].=", '" . $_xh[$parser]['vt'] . "')";
+				// G. Giunta 2005/03/12 save some chars in the reconstruction of string vals...
+				if ($_xh[$parser]['vt'] != $xmlrpcString)
+					$_xh[$parser]['st'].=", '" . $_xh[$parser]['vt'] . "')";
+				else
+					$_xh[$parser]['st'].=")";
 				if ($_xh[$parser]['cm'])
 				{
 					$_xh[$parser]['st'].=',';
+				}*/
+
+				// build the xmlrpc val out of the data received, and substitute it
+				$temp = new xmlrpcval($_xh[$parser]['value'], $_xh[$parser]['vt']);
+				// check if we are inside an array or struct:
+				// if value just built is inside an array, let's move it into array on the stack
+				if ($_xh[$parser]['vsp'] && $_xh[$parser]['valuestack'][$_xh[$parser]['vsp']-1]['type']=='ARRAY')
+				{
+					$_xh[$parser]['valuestack'][$_xh[$parser]['vsp']-1]['values'][] = $temp;
+				}
+				else
+				{
+					$_xh[$parser]['value'] = $temp;
 				}
 				break;
 			case 'MEMBER':
-				$_xh[$parser]['ac']=''; $_xh[$parser]['qt']=0;
+				$_xh[$parser]['ac']='';
+				//$_xh[$parser]['qt']=0;
+				// add to array in the stack the last element built
+				// unless no VALUE was found
+				if ($_xh[$parser]['value'])
+				{
+					$_xh[$parser]['valuestack'][$_xh[$parser]['vsp']-1]['values'][$_xh[$parser]['valuestack'][$_xh[$parser]['vsp']-1]['name']] = $_xh[$parser]['value'];
+				}
+				else
+					error_log('XML-RPC: missing VALUE inside STRUCT in received xml');
 				break;
 			case 'DATA':
-				$_xh[$parser]['ac']=''; $_xh[$parser]['qt']=0;
+				$_xh[$parser]['ac']='';
+				//$_xh[$parser]['qt']=0;
 				break;
 			case 'PARAM':
-				$_xh[$parser]['params'][]=$_xh[$parser]['st'];
+				//$_xh[$parser]['params'][]=$_xh[$parser]['st'];
+				if ($_xh[$parser]['value'])
+					$_xh[$parser]['params'][]=$_xh[$parser]['value'];
+				else
+					error_log('XML-RPC: missing VALUE inside PARAM in received xml');
 				break;
 			case 'METHODNAME':
 				$_xh[$parser]['method']=ereg_replace("^[\n\r\t ]+", '', $_xh[$parser]['ac']);
 				break;
-			case 'BOOLEAN':
-				// special case here: we translate boolean 1 or 0 into PHP
-				// constants true or false
-				if ($_xh[$parser]['ac']=='1')
-				{
-					$_xh[$parser]['ac']='true';
-				}
-				else
-				{
-					$_xh[$parser]['ac']='false';
-					$_xh[$parser]['vt']=strtolower($name);
-				}
+			case 'PARAMS':
+			case 'FAULT':
+			case 'METHODCALL':
+			case 'METHORESPONSE':
 				break;
 			default:
+				// End of INVALID ELEMENT!
+				// shall we add an assert here for unreachable code???
 				break;
 		}
+
 		// if it's a valid type name, set the type
-		if (isset($xmlrpcTypes[strtolower($name)]))
+		/*if (isset($xmlrpcTypes[strtolower($name)]))
 		{
 			$_xh[$parser]['vt']=strtolower($name);
+		}*/
+
 		}
+
 	}
 
 	function xmlrpc_cd($parser, $data)
@@ -389,37 +900,48 @@
 		//if (ereg("^[\n\r \t]+$", $data)) return;
 		// print "adding [${data}]\n";
 
-		if ($_xh[$parser]['lv']!=3)
+		// skip processing if xml fault already detected
+		if ($_xh[$parser]['isf'] < 2)
 		{
-			// "lookforvalue==3" means that we've found an entire value
-			// and should discard any further character data
-			if ($_xh[$parser]['lv']==1)
-			{
-				// if we've found text and we're just in a <value> then
-				// turn quoting on, as this will be a string
-				$_xh[$parser]['qt']=1; 
-				// and say we've found a value
-				$_xh[$parser]['lv']=2; 
-			}
-			if(!@isset($_xh[$parser]['ac']))
+			if ($_xh[$parser]['lv']!=3)
 			{
-				$_xh[$parser]['ac'] = '';
+				// "lookforvalue==3" means that we've found an entire value
+				// and should discard any further character data
+				if ($_xh[$parser]['lv']==1)
+				{
+					// if we've found text and we're just in a <value> then
+					// turn quoting on, as this will be a string
+					//$_xh[$parser]['qt']=1;
+					// and say we've found a value
+					$_xh[$parser]['lv']=2;
+				}
+				if(!@isset($_xh[$parser]['ac']))
+				{
+					$_xh[$parser]['ac'] = '';
+				}
+				//$_xh[$parser]['ac'].=str_replace('$', '\$', str_replace('"', '\"', str_replace(chr(92),$xmlrpc_backslash, $data)));
+				$_xh[$parser]['ac'].=$data;
 			}
-			$_xh[$parser]['ac'].=str_replace('$', '\$', str_replace('"', '\"', str_replace(chr(92),$xmlrpc_backslash, $data)));
 		}
 	}
 
 	function xmlrpc_dh($parser, $data)
 	{
-		global $_xh;
-		if (substr($data, 0, 1) == '&' && substr($data, -1, 1) == ';')
+		global $_xh, $xmlrpc_backslash;
+
+		// skip processing if xml fault already detected
+		if ($_xh[$parser]['isf'] < 2)
 		{
-			if ($_xh[$parser]['lv']==1)
+			if (substr($data, 0, 1) == '&' && substr($data, -1, 1) == ';')
 			{
-				$_xh[$parser]['qt']=1; 
-				$_xh[$parser]['lv']=2; 
+				if ($_xh[$parser]['lv']==1)
+				{
+					//$_xh[$parser]['qt']=1;
+					$_xh[$parser]['lv']=2;
+				}
+				//$_xh[$parser]['ac'].=str_replace('$', '\$', str_replace('"', '\"', str_replace(chr(92),$xmlrpc_backslash, $data)));
+				$_xh[$parser]['ac'].=$data;
 			}
-			$_xh[$parser]['ac'].=str_replace('$', '\$', str_replace('"', '\"', str_replace(chr(92),$xmlrpc_backslash, $data)));
 		}
 	}
 
@@ -429,7 +951,7 @@
 		var $server;
 		var $port;
 		var $errno;
-		var $errstring;
+		var $errstr;
 		var $debug=0;
 		var $username='';
 		var $password='';
@@ -501,27 +1023,32 @@
 			else
 			{
 				return $this->sendPayloadHTTP10($msg, $this->server, $this->port,
-				$timeout, $this->username, 
+				$timeout, $this->username,
 				$this->password);
 			}
 		}
 
 		function sendPayloadHTTP10($msg, $server, $port, $timeout=0,$username='', $password='')
 		{
-			global $xmlrpcerr, $xmlrpcstr;
+			global $xmlrpcerr, $xmlrpcstr, $xmlrpcName, $xmlrpcVersion, $xmlrpc_defencoding;
 			if ($port==0)
 			{
 				$port=80;
 			}
 			if($timeout>0)
 			{
-				$fp=fsockopen($server, $port,$this->errno, $this->errstr, $timeout);
+				$fp=@fsockopen($server, $port,$this->errno, $this->errstr, $timeout);
 			}
 			else
 			{
-				$fp=fsockopen($server, $port,$this->errno, $this->errstr);
+				$fp=@fsockopen($server, $port,$this->errno, $this->errstr);
 			}
-			if (!$fp)
+			if ($fp)
+			{
+				if ($timeout>0 && function_exists('stream_set_timeout'))
+					stream_set_timeout($fp, $timeout);
+			}
+			else
 			{
 				$this->errstr='Connect error';
 				$r=new xmlrpcresp(0, $xmlrpcerr['http_error'],$xmlrpcstr['http_error']);
@@ -541,9 +1068,11 @@
 				$credentials='Authorization: Basic ' . base64_encode($username . ':' . $password) . "\r\n";
 			}
 
-			$op= "POST " . $this->path. " HTTP/1.0\r\nUser-Agent: PHP XMLRPC 1.0\r\n" .
-				"Host: ". $this->server  . "\r\n" .
-				$credentials . 
+			$op= "POST " . $this->path. " HTTP/1.0\r\n" .
+				"User-Agent: " . $xmlrpcName . " " . $xmlrpcVersion . "\r\n" .
+				"Host: ". $server . "\r\n" .
+				$credentials .
+				"Accept-Charset: " . $xmlrpc_defencoding . "\r\n" .
 				"Content-Type: text/xml\r\nContent-Length: " .
 				strlen($msg->payload) . "\r\n\r\n" .
 				$msg->payload;
@@ -563,7 +1092,7 @@
 		// requires curl to be built into PHP
 		function sendPayloadHTTPS($msg, $server, $port, $timeout=0,$username='', $password='', $cert='',$certpass='')
 		{
-			global $xmlrpcerr, $xmlrpcstr;
+			global $xmlrpcerr, $xmlrpcstr, $xmlrpcVersion, $xmlrpc_internalencoding;
 			if ($port == 0)
 			{
 				$port = 443;
@@ -590,7 +1119,7 @@
 			{
 				curl_setopt($curl, CURLOPT_VERBOSE, 1);
 			}
-			curl_setopt($curl, CURLOPT_USERAGENT, 'PHP XMLRPC 1.0');
+			curl_setopt($curl, CURLOPT_USERAGENT, 'PHP XMLRPC '.$xmlrpcVersion);
 			// required for XMLRPC
 			curl_setopt($curl, CURLOPT_POST, 1);
 			// post the data
@@ -598,7 +1127,7 @@
 			// the data
 			curl_setopt($curl, CURLOPT_HEADER, 1);
 			// return the header too
-			curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: text/xml'));
+			curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: text/xml', 'Accept-Charset: '.$xmlrpc_internalencoding));
 			// whether to verify remote host's cert
 			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, $this->verifypeer);
 			// whether to verify cert's common name (CN); 0 for no, 1 to verify that it exists, and 2 to verify that it matches the hostname used
@@ -631,12 +1160,13 @@
 			{
 				$this->errstr='no response';
 				$resp=new xmlrpcresp(0, $xmlrpcerr['curl_fail'], $xmlrpcstr['curl_fail']. ': '. curl_error($curl));
+				curl_close($curl);
 			}
 			else
 			{
+				curl_close($curl);
 				$resp = $msg->parseResponse($result);
 			}
-			curl_close($curl);
 			return $resp;
 		}
 
@@ -649,10 +1179,10 @@
 				$results = $this->_try_multicall($msgs, $timeout, $method);
 				/* TODO - this is not php3-friendly */
 				// if($results !== false)
-				if($results != false)
+				if(is_array($results))
 				{
 					// Either the system.multicall succeeded, or the send
-					// failed (e.g. due to HTTP timeout).  In either case,
+					// failed (e.g. due to HTTP timeout). In either case,
 					// we're done for now.
 					return $results;
 				}
@@ -700,19 +1230,27 @@
 
 			// Attempt RPC call
 			$result = $this->send($multicall, $timeout, $method);
-			if (!is_object($result))
+			if(!is_object($result))
+			{
 				return ($result || 0); // transport failed
+			}
 
-			if ($result->faultCode() != 0)
+			if($result->faultCode() != 0)
+			{
 				return false;		// system.multicall failed
+			}
 
 			// Unpack responses.
 			$rets = $result->value();
-			if ($rets->kindOf() != 'array')
+			if($rets->kindOf() != 'array')
+			{
 				return false;		// bad return type from system.multicall
+			}
 			$numRets = $rets->arraysize();
-			if ($numRets != count($msgs))
+			if($numRets != count($msgs))
+			{
 				return false;		// wrong number of return values.
+			}
 
 			$response = array();
 			for ($i = 0; $i < $numRets; $i++)
@@ -721,18 +1259,24 @@
 				switch ($val->kindOf())
 				{
 				case 'array':
-					if ($val->arraysize() != 1)
+					if($val->arraysize() != 1)
+					{
 						return false;		// Bad value
+					}
 					// Normal return value
 					$response[$i] = new xmlrpcresp($val->arraymem(0));
 					break;
 				case 'struct':
 					$code = $val->structmem('faultCode');
-					if ($code->kindOf() != 'scalar' || $code->scalartyp() != 'int')
+					if($code->kindOf() != 'scalar' || $code->scalartyp() != 'int')
+					{
 						return false;
+					}
 					$str = $val->structmem('faultString');
-					if ($str->kindOf() != 'scalar' || $str->scalartyp() != 'string')
+					if($str->kindOf() != 'scalar' || $str->scalartyp() != 'string')
+					{
 						return false;
+					}
 					$response[$i] = new xmlrpcresp(0, $code->scalarval(), $str->scalarval());
 					break;
 				default:
@@ -756,12 +1300,13 @@
 			{
 				// error
 				$this->errno = $fcode;
-				$this->errstr = htmlspecialchars($fstr); // XXX: encoding probably shouldn't be done here; fix later.
+				$this->errstr = $fstr;
+				//$this->errstr = htmlspecialchars($fstr); // XXX: encoding probably shouldn't be done here; fix later.
 			}
-			else if (!is_object($val))
+			elseif (!is_object($val))
 			{
 				// programmer error
-				error_log("Invalid type '" . gettype($val) . "' (value: $val) passed to xmlrpcresp.  Defaulting to empty value.");
+				error_log("Invalid type '" . gettype($val) . "' (value: $val) passed to xmlrpcresp. Defaulting to empty value.");
 				$this->val = new xmlrpcval();
 			}
 			else
@@ -791,6 +1336,7 @@
 			$result = "<methodResponse>\n";
 			if ($this->errno)
 			{
+				// G. Giunta 2005/2/13: let non-ASCII response messages be tolerated by clients
 				$result .= '<fault>
 <value>
 <struct>
@@ -800,7 +1346,7 @@
 </member>
 <member>
 <name>faultString</name>
-<value><string>' . $this->errstr . '</string></value>
+<value><string>' . xmlrpc_encode_entitites($this->errstr) . '</string></value>
 </member>
 </struct>
 </value>
@@ -809,8 +1355,8 @@
 			else
 			{
 				$result .= "<params>\n<param>\n" .
-						$this->val->serialize() . 
-						"</param>\n</params>";
+					$this->val->serialize() .
+					"</param>\n</params>";
 			}
 			$result .= "\n</methodResponse>";
 			return $result;
@@ -838,7 +1384,7 @@
 
 		function xml_header()
 		{
-			return "<?xml version=\"1.0\"?>\n<methodCall>\n";
+			return "<?xml version=\"1.0\"?" . ">\n<methodCall>\n";
 		}
 
 		function xml_footer()
@@ -861,7 +1407,7 @@
 			$this->payload.="</params>\n";
 			// }
 			$this->payload.=$this->xml_footer();
-			$this->payload=str_replace("\n", "\r\n", $this->payload);
+			//$this->payload=str_replace("\n", "\r\n", $this->payload);
 		}
 
 		function method($meth='')
@@ -896,24 +1442,7 @@
 		function parseResponse($data='')
 		{
 			global $_xh,$xmlrpcerr,$xmlrpcstr;
-			global $xmlrpc_defencoding;
-
-			$parser = xml_parser_create($xmlrpc_defencoding);
-
-			$_xh[$parser]=array();
-
-			$_xh[$parser]['st']='';
-			$_xh[$parser]['cm']=0;
-			$_xh[$parser]['isf']=0;
-			$_xh[$parser]['ac']='';
-			$_xh[$parser]['qt']='';
-			$_xh[$parser]['headers'] = array();
-
-			xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, true);
-			xml_set_element_handler($parser, 'xmlrpc_se', 'xmlrpc_ee');
-			xml_set_character_data_handler($parser, 'xmlrpc_cd');
-			xml_set_default_handler($parser, 'xmlrpc_dh');
-			$xmlrpc_value=new xmlrpcval;
+			global $xmlrpc_defencoding, $xmlrpc_internalencoding;
 
 			$hdrfnd = 0;
 			if($this->debug)
@@ -926,45 +1455,133 @@
 			{
 				error_log('No response received from server.');
 				$r = new xmlrpcresp(0, $xmlrpcerr['no_data'], $xmlrpcstr['no_data']);
-				xml_parser_free($parser);
 				return $r;
 			}
 			// see if we got an HTTP 200 OK, else bomb
 			// but only do this if we're using the HTTP protocol.
-			if(ereg("^HTTP",$data) && !ereg("^HTTP/[0-9\.]+ 200 ", $data))
+			if(ereg("^HTTP",$data))
 			{
-				$errstr= substr($data, 0, strpos($data, "\n")-1);
-				error_log('HTTP error, got response: ' .$errstr);
-				$r=new xmlrpcresp(0, $xmlrpcerr['http_error'], $xmlrpcstr['http_error']. ' (' . $errstr . ')');
-				xml_parser_free($parser);
-				return $r;
+				// Strip HTTP 1.1 100 Continue header if present
+				while (ereg('^HTTP/1.1 1[0-9]{2}', $data))
+				{
+					$pos = strpos($data, 'HTTP', 12);
+					// server sent a Continue header without any (valid) content following...
+					// give the client a chance to know it
+					if (!$pos && !is_int($pos)) // works fine in php 3, 4 and 5
+						break;
+					$data = substr($data, $pos);
+				}
+				if (!ereg("^HTTP/[0-9\\.]+ 200 ", $data))
+				{
+					$errstr= substr($data, 0, strpos($data, "\n")-1);
+					error_log('HTTP error, got response: ' .$errstr);
+					$r=new xmlrpcresp(0, $xmlrpcerr['http_error'], $xmlrpcstr['http_error']. ' (' . $errstr . ')');
+					return $r;
+				}
 			}
+			$parser = xml_parser_create($xmlrpc_defencoding);
+
+			// G. Giunta 2004/04/06
+			// Clean up the accumulator, or it will grow indefinitely long
+			// if making xmlrpc calls for a while
+			$_xh=array();
+			$_xh[$parser]=array();
+			$_xh[$parser]['headers'] = array();
+			$_xh[$parser]['stack'] = array();
+			$_xh[$parser]['sp'] = 0;
+			$_xh[$parser]['valuestack'] = array();
+			$_xh[$parser]['vsp'] = 0;
 
 			// separate HTTP headers from data
 			if (ereg("^HTTP", $data))
 			{
-				$ar = split("\r\n", $data);
-				while (($line = array_shift($ar)))
+				// be tolerant to usage of \n instead of \r\n to separate headers and data
+				// (even though it is not valid http)
+				$pos = strpos($data,"\r\n\r\n");
+				if($pos || is_int($pos))
+					$bd = $pos+4;
+				else
 				{
-					if (strlen($line) < 1)
+					$pos = strpos($data,"\n\n");
+					if($pos || is_int($pos))
+						$bd = $pos+2;
+					else
 					{
-						break;
+						// No separation between response headers and body: fault?
+						$bd = 0;
 					}
-					$_xh[$parser]['headers'][] = $line;
 				}
-				$data = join("\r\n", $ar);
-			}
-				
-			if ($this->debug && count($_xh[$parser]['headers']))
-			{
-				print "<PRE>";
-				foreach ($_xh[$parser]['headers'] as $header)
+				// be tolerant to line endings, and extra empty lines
+				$ar = split("\r?\n", trim(substr($data, 0, $pos)));
+				while (list(,$line) = @each($ar))
+				{
+					// take care of multi-line headers
+					$arr = explode(':',$line);
+					if(count($arr) > 1)
+					{
+						$header_name = trim($arr[0]);
+						// TO DO: some headers (the ones that allow a CSV list of values)
+						// do allow many values to be passed using multiple header lines.
+						// We should add content to $_xh[$parser]['headers'][$header_name]
+						// instead of replacing it for those...
+						$_xh[$parser]['headers'][$header_name] = $arr[1];
+						for ($i = 2; $i < count($arr); $i++)
+						{
+							$_xh[$parser]['headers'][$header_name] .= ':'.$arr[$i];
+						} // while
+						$_xh[$parser]['headers'][$header_name] = trim($_xh[$parser]['headers'][$header_name]);
+					} else if (isset($header_name))
+					{
+						$_xh[$parser]['headers'][$header_name] .= ' ' . trim($line);
+					}
+				}
+				$data = substr($data, $bd);
+
+				if ($this->debug && count($_xh[$parser]['headers']))
 				{
-					print "HEADER: $header\n";
+					print '<PRE>';
+					//foreach ($_xh[$parser]['headers'] as $header)
+					@reset($_xh[$parser]['headers']);
+					while(list($header, $value) = @each($_xh[$parser]['headers']))
+					{
+						print "HEADER: $header: $value\n";
+					}
+					print "</PRE>\n";
 				}
-				print "</PRE>\n";
 			}
 
+			// be tolerant of extra whitespace in response body
+			$data = trim($data);
+
+			// be tolerant of junk after methodResponse (e.g. javascript automatically inserted by free hosts)
+			// idea from Luca Mariano <luca.mariano@email.it> originally in PEARified version of the lib
+			$bd = false;
+			$pos = strpos($data, "</methodResponse>");
+			while ($pos || is_int($pos))
+			{
+				$bd = $pos+17;
+				$pos = strpos($data, "</methodResponse>", $bd);
+			}
+			if ($bd)
+				$data = substr($data, 0, $bd);
+
+			//$_xh[$parser]['st']='';
+			//$_xh[$parser]['cm']=0;
+			$_xh[$parser]['isf']=0;
+			$_xh[$parser]['isf_reason']=0;
+			$_xh[$parser]['ac']='';
+			//$_xh[$parser]['qt']='';
+
+			xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, true);
+			// G. Giunta 2005/02/13: PHP internally uses ISO-8859-1, so we have to tell
+			// the xml parser to give us back data in the expected charset
+			xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, $xmlrpc_internalencoding);
+
+			xml_set_element_handler($parser, 'xmlrpc_se', 'xmlrpc_ee');
+			xml_set_character_data_handler($parser, 'xmlrpc_cd');
+			xml_set_default_handler($parser, 'xmlrpc_dh');
+			//$xmlrpc_value=new xmlrpcval;
+
 			if (!xml_parse($parser, $data, sizeof($data)))
 			{
 				// thanks to Peter Kocks <peter.kocks@baygate.com>
@@ -977,21 +1594,29 @@
 					$errstr = sprintf('XML error: %s at line %d',
 						xml_error_string(xml_get_error_code($parser)),
 						xml_get_current_line_number($parser));
-						error_log($errstr);
-						$r=new xmlrpcresp(0, $xmlrpcerr['invalid_return'], $xmlrpcstr['invalid_return']);
-					xml_parser_free($parser);
-					echo $errstr;
-					return $r;
 				}
+				error_log($errstr);
+				$r=new xmlrpcresp(0, $xmlrpcerr['invalid_return'], $xmlrpcstr['invalid_return'].' ('.$errstr.')');
+				xml_parser_free($parser);
+				if ($this->debug)
+					echo $errstr;
+				$r->hdrs = $_xh[$parser]['headers'];
+				return $r;
 			}
 			xml_parser_free($parser);
-			if ($this->debug)
+
+			if ($_xh[$parser]['isf'] > 1)
 			{
-				print "<PRE>---EVALING---[" . 
-				strlen($_xh[$parser]['st']) . " chars]---\n" . 
-				htmlspecialchars($_xh[$parser]['st']) . ";\n---END---</PRE>";
+				if ($this->debug)
+				{
+					///@todo echo something for user?
+				}
+
+				$r = new xmlrpcresp(0, $xmlrpcerr['invalid_return'],
+				$xmlrpcstr['invalid_return'] . ' ' . $_xh[$parser]['isf_reason']);
 			}
-			if (strlen($_xh[$parser]['st'])==0)
+			//else if (strlen($_xh[$parser]['st'])==0)
+			else if (!is_object($_xh[$parser]['value']))
 			{
 				// then something odd has happened
 				// and it's time to generate a client side error
@@ -1001,7 +1626,25 @@
 			}
 			else
 			{
-				eval('$v=' . $_xh[$parser]['st'] . '; $allOK=1;');
+
+				if ($this->debug)
+				{
+					//print "<PRE>---EVALING---[" .
+					//strlen($_xh[$parser]['st']) . " chars]---\n" .
+					//htmlspecialchars($_xh[$parser]['st']) . ";\n---END---</PRE>";
+					print "<PRE>---PARSED---\n" ;
+					var_dump($_xh[$parser]['value']);
+					print "\n---END---</PRE>";
+				}
+
+				//$allOK=0;
+				//@eval('$v=' . $_xh[$parser]['st'] . '; $allOK=1;');
+				//if (!$allOK)
+				//{
+				//	$r = new xmlrpcresp(0, $xmlrpcerr['invalid_return'], $xmlrpcstr['invalid_return']);
+				//}
+				//else
+				$v = $_xh[$parser]['value'];
 				if ($_xh[$parser]['isf'])
 				{
 					$errno_v = $v->structmem('faultCode');
@@ -1037,7 +1680,7 @@
 			global $xmlrpcTypes;
 			$this->me=array();
 			$this->mytype=0;
-			if ($val!=-1 || $type!='')
+			if ($val!=-1 || !is_int($val) || $type!='')
 			{
 				if ($type=='')
 				{
@@ -1168,7 +1811,7 @@
 			$rs='';
 			global $xmlrpcTypes, $xmlrpcBase64, $xmlrpcString,
 			$xmlrpcBoolean;
-			switch($xmlrpcTypes[$typ])
+			switch(@$xmlrpcTypes[$typ])
 			{
 				case 3:
 					// struct
@@ -1201,7 +1844,10 @@
 							$rs.="<${typ}>" . ($val ? '1' : '0') . "</${typ}>";
 							break;
 						case $xmlrpcString:
-							$rs.="<${typ}>" . htmlspecialchars($val). "</${typ}>";
+							// G. Giunta 2005/2/13: do NOT use htmlentities, since
+							// it will produce named html entities, which are invalid xml
+							$rs.="<${typ}>" . xmlrpc_encode_entitites($val). "</${typ}>";
+							// $rs.="<${typ}>" . htmlentities($val). "</${typ}>";
 							break;
 						default:
 							$rs.="<${typ}>${val}</${typ}>";
@@ -1220,7 +1866,7 @@
 
 		function serializeval($o)
 		{
-			global $xmlrpcTypes;
+			//global $xmlrpcTypes;
 			$rs='';
 			$ar=$o->me;
 			reset($ar);
@@ -1279,7 +1925,8 @@
 				@reset($t);
 				while(list($id,$cont) = @each($t))
 				{
-					eval('$b->'.$id.' = $cont;');
+					//eval('$b->'.$id.' = $cont;');
+					@$b->$id = $cont;
 				}
 			}
 			// end contrib
@@ -1288,7 +1935,7 @@
 
 		function scalarval()
 		{
-			global $xmlrpcBoolean, $xmlrpcBase64;
+			//global $xmlrpcBoolean, $xmlrpcBase64;
 			reset($this->me);
 			list($a,$b)=each($this->me);
 			return $b;
@@ -1329,8 +1976,8 @@
 		//
 		// "Don't assume a timezone. It should be specified by the server in its
 		// documentation what assumptions it makes about timezones."
-		// 
-		// these routines always assume localtime unless 
+		//
+		// these routines always assume localtime unless
 		// $utc is set to 1, in which case UTC is assumed
 		// and an adjustment for locale is made when encoding
 		if (!$utc)
@@ -1367,17 +2014,17 @@
 			{
 				$t=mktime($regs[4], $regs[5], $regs[6], $regs[2], $regs[3], $regs[1]);
 			}
-		} 
+		}
 		return $t;
 	}
 
 	/****************************************************************
-	* xmlrpc_decode_ex takes a message in PHP xmlrpc object format and *
+	* xmlrpc_decode takes a message in PHP xmlrpc object format and *
 	* tranlates it into native PHP types.                           *
 	*                                                               *
 	* author: Dan Libby (dan@libby.com)                             *
 	****************************************************************/
-	function xmlrpc_decode_ex($xmlrpc_val)
+	function php_xmlrpc_decode($xmlrpc_val)
 	{
 		$kind = $xmlrpc_val->kindOf();
 
@@ -1392,9 +2039,9 @@
 
 			for($i = 0; $i < $size; $i++)
 			{
-				$arr[]=xmlrpc_decode_ex($xmlrpc_val->arraymem($i));
+				$arr[] = php_xmlrpc_decode($xmlrpc_val->arraymem($i));
 			}
-			return $arr; 
+			return $arr;
 		}
 		elseif($kind == 'struct')
 		{
@@ -1403,14 +2050,54 @@
 
 			while(list($key,$value)=$xmlrpc_val->structeach())
 			{
-				$arr[$key] = xmlrpc_decode_ex($value);
+				$arr[$key] = php_xmlrpc_decode($value);
 			}
 			return $arr;
 		}
 	}
 
+	if(function_exists('xmlrpc_decode'))
+	{
+		define('XMLRPC_EPI_ENABLED','1');
+	}
+	else
+	{
+		define('XMLRPC_EPI_ENABLED','0');
+		function xmlrpc_decode($xmlrpc_val)
+		{
+			$kind = $xmlrpc_val->kindOf();
+
+			if($kind == 'scalar')
+			{
+				return $xmlrpc_val->scalarval();
+			}
+			elseif($kind == 'array')
+			{
+				$size = $xmlrpc_val->arraysize();
+				$arr = array();
+
+				for($i = 0; $i < $size; $i++)
+				{
+					$arr[]=xmlrpc_decode($xmlrpc_val->arraymem($i));
+				}
+				return $arr;
+			}
+			elseif($kind == 'struct')
+			{
+				$xmlrpc_val->structreset();
+				$arr = array();
+
+				while(list($key,$value)=$xmlrpc_val->structeach())
+				{
+					$arr[$key] = xmlrpc_decode($value);
+				}
+				return $arr;
+			}
+		}
+	}
+
 	/****************************************************************
-	* xmlrpc_encode_ex takes native php types and encodes them into    *
+	* xmlrpc_encode takes native php types and encodes them into    *
 	* xmlrpc PHP object format.                                     *
 	* BUG: All sequential arrays are turned into structs.  I don't  *
 	* know of a good way to determine if an array is sequential     *
@@ -1421,7 +2108,7 @@
 	*                                                               *
 	* author: Dan Libby (dan@libby.com)                             *
 	****************************************************************/
-	function xmlrpc_encode_ex($php_val)
+	function php_xmlrpc_encode($php_val)
 	{
 		global $xmlrpcInt;
 		global $xmlrpcDouble;
@@ -1440,7 +2127,7 @@
 				$arr = array();
 				while (list($k,$v) = each($php_val))
 				{
-					$arr[$k] = xmlrpc_encode_ex($v);
+					$arr[$k] = php_xmlrpc_encode($v);
 				}
 				$xmlrpc_val->addStruct($arr);
 				break;
@@ -1459,14 +2146,67 @@
 				$xmlrpc_val->addScalar($php_val, $xmlrpcBoolean);
 				break;
 				// </G_Giunta_2001-02-29>
-			case 'unknown type':
+			// catch "resource", "NULL", "user function", "unknown type"
+			//case 'unknown type':
 			default:
 				// giancarlo pinerolo <ping@alt.it>
-				// it has to return 
+				// it has to return
 				// an empty object in case (which is already
-				// at this point), not a boolean. 
+				// at this point), not a boolean.
 				break;
+			}
+			return $xmlrpc_val;
+	}
+
+	if(XMLRPC_EPI_ENABLED == '0')
+	{
+		function xmlrpc_encode($php_val)
+		{
+			global $xmlrpcInt;
+			global $xmlrpcDouble;
+			global $xmlrpcString;
+			global $xmlrpcArray;
+			global $xmlrpcStruct;
+			global $xmlrpcBoolean;
+
+			$type = gettype($php_val);
+			$xmlrpc_val = new xmlrpcval;
+
+			switch($type)
+			{
+				case 'array':
+				case 'object':
+					$arr = array();
+					while (list($k,$v) = each($php_val))
+					{
+						$arr[$k] = xmlrpc_encode($v);
+					}
+					$xmlrpc_val->addStruct($arr);
+					break;
+				case 'integer':
+					$xmlrpc_val->addScalar($php_val, $xmlrpcInt);
+					break;
+				case 'double':
+					$xmlrpc_val->addScalar($php_val, $xmlrpcDouble);
+					break;
+				case 'string':
+					$xmlrpc_val->addScalar($php_val, $xmlrpcString);
+					break;
+					// <G_Giunta_2001-02-29>
+					// Add support for encoding/decoding of booleans, since they are supported in PHP
+				case 'boolean':
+					$xmlrpc_val->addScalar($php_val, $xmlrpcBoolean);
+					break;
+					// </G_Giunta_2001-02-29>
+				//case 'unknown type':
+				default:
+					// giancarlo pinerolo <ping@alt.it>
+					// it has to return
+					// an empty object in case (which is already
+					// at this point), not a boolean.
+					break;
+			}
+			return $xmlrpc_val;
 		}
-		return $xmlrpc_val;
 	}
 ?>
diff -urN soojung-0.4.12/libs/xmlrpcs.inc soojung/libs/xmlrpcs.inc
--- soojung-0.4.12/libs/xmlrpcs.inc	2004-08-30 21:22:54.000000000 +0900
+++ soojung/libs/xmlrpcs.inc	2005-11-09 09:37:59.000000000 +0900
@@ -1,7 +1,7 @@
 <?php
 // by Edd Dumbill (C) 1999-2002
 // <edd@usefulinc.com>
-// $Id: xmlrpcs.inc,v 1.1.1.1 2004/08/30 12:22:54 ddt Exp $
+// $Id: xmlrpcs.inc,v 1.2 2005/11/09 00:37:59 ddt Exp $
 
 // Copyright (c) 1999,2000,2002 Edd Dumbill.
 // All rights reserved.
@@ -283,7 +283,7 @@
 			global $_xmlrpc_debuginfo;
 			if ($_xmlrpc_debuginfo!='')
 			{
-				return "<!-- DEBUG INFO:\n\n" . $_xmlrpc_debuginfo . "\n-->\n";
+				return "<!-- DEBUG INFO:\n\n" . xmlrpc_encode_entitites($_xmlrpc_debuginfo) . "\n-->\n";
 			}
 			else
 			{
@@ -293,14 +293,15 @@
 
 		function service()
 		{
-			global $xmlrpc_defencoding;
+			//global $xmlrpc_defencoding;
 
 			$r=$this->parseRequest();
-			$payload='<?xml version="1.0" encoding="' . $xmlrpc_defencoding . '"?>' . "\n"
+			//$payload='<?xml version="1.0" encoding="' . $xmlrpc_defencoding . '"?' . '>' . "\n"
+			$payload='<?xml version="1.0" ?' . '>' . "\n"
 				. $this->serializeDebug()
 				. $r->serialize();
-			Header("Content-type: text/xml\r\nContent-length: " . 
-			strlen($payload));
+			header('Content-Type: text/xml');
+			header('Content-Length: ' . (int)strlen($payload));
 			print $payload;
 		}
 
@@ -347,35 +348,50 @@
 					}
 					if ($itsOK)
 					{
-						return array(1);
+						return array(1,'');
 					}
 				}
 			}
-			return array(0, "Wanted ${wanted}, got ${got} at param ${pno})");
+			if (isset($wanted))
+				return array(0, "Wanted ${wanted}, got ${got} at param ${pno})");
+			else
+				return array(0, "No method signature matches number of parameters");
 		}
 
 		function parseRequest($data='')
 		{
 			global $_xh,$HTTP_RAW_POST_DATA;
 			global $xmlrpcerr, $xmlrpcstr, $xmlrpcerrxml, $xmlrpc_defencoding,
-			$_xmlrpcs_dmap;
+			$_xmlrpcs_dmap, $xmlrpc_internalencoding;
 
 			if ($data=='')
 			{
 				$data=$HTTP_RAW_POST_DATA;
 			}
+            // G. Giunta 2005/02/13: we do NOT expect to receive html entities
+            // so we do not try to convert them into xml character entities
+			//$data = xmlrpc_html_entity_xlate($data);
 			$parser = xml_parser_create($xmlrpc_defencoding);
 
 			$_xh[$parser]=array();
-			$_xh[$parser]['st']='';
-			$_xh[$parser]['cm']=0;
+			//$_xh[$parser]['st']='';
+			//$_xh[$parser]['cm']=0;
 			$_xh[$parser]['isf']=0;
+			$_xh[$parser]['isf_reason']='';
 			$_xh[$parser]['params']=array();
+			$_xh[$parser]['stack'] = array();
+			$_xh[$parser]['sp'] = 0;
+			$_xh[$parser]['valuestack'] = array();
+			$_xh[$parser]['vsp'] = 0;
 			$_xh[$parser]['method']='';
 
 			// decompose incoming XML into request structure
 
 			xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, true);
+            // G. Giunta 2005/02/13: PHP internally uses ISO-8859-1, so we have to tell
+            // the xml parser to give us back data in the expected charset
+            xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, $xmlrpc_internalencoding);
+
 			xml_set_element_handler($parser, 'xmlrpc_se', 'xmlrpc_ee');
 			xml_set_character_data_handler($parser, 'xmlrpc_cd');
 			xml_set_default_handler($parser, 'xmlrpc_dh');
@@ -390,21 +406,45 @@
 				xml_parser_free($parser);
 			}
 			else
+			if ($_xh[$parser]['isf'])
 			{
 				xml_parser_free($parser);
+				$r=new xmlrpcresp(0,
+					$xmlrpcerr['invalid_request'],
+					$xmlrpcstr['invalid_request'] . ' ' . $_xh[$parser]['isf_reason']);
+			}
+			else
+			{
+				xml_parser_free($parser);
+
 				$m=new xmlrpcmsg($_xh[$parser]['method']);
 				// now add parameters in
 				$plist='';
+				//$allOK = 1;
 				for($i=0; $i<sizeof($_xh[$parser]['params']); $i++)
 				{
 					//print "<!-- " . $_xh[$parser]['params'][$i]. "-->\n";
-					$plist.="$i - " .  $_xh[$parser]['params'][$i]. " \n";
-					eval('$m->addParam(' . $_xh[$parser]['params'][$i]. ');');
+					$plist.="$i - " .  $_xh[$parser]['params'][$i]. ";\n";
+					//$allOK = 0;
+					//@eval('$m->addParam(' . $_xh[$parser]['params'][$i]. '); $allOK=1;');
+					@$m->addParam($_xh[$parser]['params'][$i]);
+					//if (!$allOK)
+					//{
+					//	break;
+					//}
 				}
 				// uncomment this to really see what the server's getting!
 				// xmlrpc_debugmsg($plist);
-
-				$r = $this->execute($m);
+				//if (!$allOK)
+				//{
+				//	$r = new xmlrpcresp(0,
+  				//		$xmlrpcerr['incorrect_params'],
+				//		$xmlrpcstr['incorrect_params'] . ": xml error in param " . $i);
+				//}
+				//else
+				//{
+					$r = $this->execute($m);
+				//}
 			}
 			return $r;
 		}
@@ -429,13 +469,15 @@
 			if (isset($dmap[$methName]['signature']))
 			{
 				$sig = $dmap[$methName]['signature'];
-				list ($ok, $errstr) = $this->verifySignature($m, $sig);
-				if (!$ok)
+				list($ok, $errstr) = $this->verifySignature($m, $sig);
+				if(!$ok)
 				{
 					// Didn't match.
-					return new xmlrpcresp(0,
+					return new xmlrpcresp(
+						0,
 						$xmlrpcerr['incorrect_params'],
-						$xmlrpcstr['incorrect_params'] . ": ${errstr}");
+						$xmlrpcstr['incorrect_params'] . ": ${errstr}"
+					);
 				}
 			}
 
diff -urN soojung-0.4.12/rss2.php soojung/rss2.php
--- soojung-0.4.12/rss2.php	2005-07-12 06:31:01.000000000 +0900
+++ soojung/rss2.php	2005-11-10 10:38:42.000000000 +0900
@@ -16,12 +16,12 @@
 ?>
 <rss version="2.0">
 <channel>
-<title><?=htmlspecialchars(convenc($blog_name))?></title>
-<link><?=$blog_baseurl?></link>
-<description><?=htmlspecialchars(convenc($blog_desc))?></description>
+<title><?=htmlspecialchars(convenc($blog_name)) ?></title>
+<link><?php echo $blog_baseurl ?></link>
+<description><?php echo htmlspecialchars(convenc($blog_desc)) ?></description>
 <copyright></copyright>
-<pubDate><?=date('r')?></pubDate>
-<generator>soojung <?=$soojung_version?></generator>
+<pubDate><?php echo date('r') ?></pubDate>
+<generator>soojung <?php echo $soojung_version ?></generator>
 
 <?php
 if (isset($_GET['category'])) {
diff -urN soojung-0.4.12/settings.php soojung/settings.php
--- soojung-0.4.12/settings.php	2005-10-25 09:58:57.000000000 +0900
+++ soojung/settings.php	2005-11-10 10:38:42.000000000 +0900
@@ -1,6 +1,6 @@
 <?php
 
-$soojung_version = '0.4.12';
+$soojung_version = '0.4.13';
 setlocale(LC_TIME, "C");
 
 header("Content-type: text/html; charset=utf-8");
diff -urN soojung-0.4.12/templates/admin/upload.tpl soojung/templates/admin/upload.tpl
--- soojung-0.4.12/templates/admin/upload.tpl	2005-09-22 11:56:57.000000000 +0900
+++ soojung/templates/admin/upload.tpl	2005-10-29 01:34:49.000000000 +0900
@@ -24,7 +24,7 @@
 <td>
 <strong>
 <a href="#" onclick="return appendLink('{$baseurl}', '{$file.path|escape:'quotes'|escape}', '{$file.name|escape}');">append</a>
-<a href="{$baseurl}/upload.php?mode=delete&file={$file.path|escape:'url'|escape}">delete</a>
+<a href="{$baseurl}/upload.php?mode=delete&file={$file.path|escape:'url'|escape}" onClick="return confirm('Are you sure want to delete file?')">delete</a>
 </strong>
 </td>
 </tr>
